/*
UserOptions.h
*/

#ifndef __USEROPTIONS_H
#define __USEROPTIONS_H

#include <stdarg.h>
#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include <stdio.h>
#include <ctype.h>
#include <signal.h>

#include "Utils.h"
#include "Config.h"
#include "Configuration.h"
#include "XString.h"
#include "XVector.h"
#include "IMAP.h"

typedef XVector<XString> StringList;

#define DEF_USEROPT_FILE "[main]\nmsgsperindexpage=10\ninsigninnewmsg=0\npersonalname=\nsavemsgsentmail=0\n" \
                         "replyfrom=0\nforwattachs=1\nheightwritearea=30\nwidthwritearea=70\ntruncatelengthreadingmsg=90\n" \
                         "confirmpurge=1\nconfirmlogout=1\n" \
                         "skin=DEFAULT\nrefreshtime=0\nsentmailname="DEFOPT_SENTMAILBOX"\n\n"

class UserOptions
  {
  private:
    Configuration *TheConf;
    TBuffer StatusLine;
    XString user, imapserver, basepath, userdir, userattdir, fnuseroptions, fnsignature, fnsavedmsg, SentmailName;
    bool InsertSignatureInNewMsg, SaveMsgSentMail, ForwAttachs, ReplyFrom, WorkingWithCookies, UseJavaScript,
         ConfirmPurge, ConfirmLogout;
    long MsgsPerIndexPage, CurrentPosition, TotalMsgs, MAILBOXSIZE, BeginPage;
    XString personalname, signature;
    int msgtoanswer, validator, pageid, lastcmd, sort_ab, TruncateLengthReadingMsg, WidthWriteArea, 
        HeightWriteArea, RefreshTime, IMAPPORT, timeout;
    StringList SLAttachList, SLAttachListInfo, PilaCmds;
    IPNAME MAILDOMAIN, IMAPSERVER, SMTPSERVER;
    TBuffer MAILBOXPREFIX;
    char skin[MAXLENGTHSKIN + 1];
    COLORHTML COLOR_BGTABLE, COLOR_BGTABLECOPYRIGHT, COLOR_BGBOTONERA, COLOR_BGTABLEMSGINDEX, COLOR_BGBODY,
              COLOR_BGTEXTO, COLOR_BGFILASMSGINDEX, COLOR_BGFILASADDBOOK, COLOR_BGFILASREADINGMSG,
              COLOR_FONT_TABLE, COLOR_FONT_MAIN, COLOR_FONT_STATUS, COLOR_FONT_STATUSLINE;
    FONTNAME FONT_TABLE, FONT_MAIN, FONT_STATUS;
    FONTSIZE FONT_TABLE_SIZE, FONT_MAIN_SIZE, FONT_STATUS_SIZE, FONT_BOTONERA_SIZE;
    TSBuffer IMG_BG;
  public:
    UserOptions (const char *abasepath, const char *auser, const char *aimapserver);
    virtual ~UserOptions (); 
    void leeConf ();
    void InitStatusLine (void);
    const char *getStatusLine (void);
    void setStatusLine (char *newstatusline, char *htmlcolor);
    int getValidator (void);
    void IncValidator (void);
    void setCurrentPosition (long pos, long total);
    long getCurrentPosition (void);
    long getBeginPage (void);    
    void setMailboxSize (long asize);
    long getMailboxSize (void);    
    long getTotalMsgs (void);
    void setInsertSignatureInNewMsg (bool value);
    bool getInsertSignatureInNewMsg (void); 
    void setMailDomain (const char *amaildomain);
    char *getMailDomain (void);
    void setImapServer (const char *aimapserver);
    char *getImapServer (void);                  
    void setImapPort (int aimapport);
    int getImapPort (void);                  
    void setSMTPServer (const char *asmtpserver);
    char *getSMTPServer (void);        
    void setMailboxPrefix (const char *amailboxprefix);
    char *getMailboxPrefix (void);
    const char *getUsername (void);
    const char *getAttachDir (void);    
    void setMsgsPerIndexPage (long value);
    long getMsgsPerIndexPage (void);
    void setPersonalName (char *value);
    char *getPersonalName (void);
    bool getSaveMsgSentMail (void);
    void setSaveMsgSentMail (bool value);
    void setReplyFrom (bool value);
    bool getReplyFrom (void);
    void setForwAttachs (bool value);
    bool getForwAttachs (void);
    void setTruncateLengthReadingMsg (int value);
    int getTruncateLengthReadingMsg (void);
    void setWidthWriteArea (int value);
    int  getWidthWriteArea (void);    
    void setHeightWriteArea (int value);
    int  getHeightWriteArea (void);            
    void setRefreshTime (int value);
    int  getRefreshTime (void);            
    char *getSignature (void);
    bool SaveOptions (char *tmpfilename);
    void LoadOptions (void);
    int numAttachs (void);
    char *getFileNameAttach (int p);
    char *getTrueFileNameAttach (int p);
    char *getAttachInfo (int p);
    int addFileNameAtach (char *newfile, char *info);
    int delFileNameAtach (char *attachnumbers);
    void delAllAttachs (void);
    void setSort_ab (int value);
    int getSort_ab (void);    
    char *getfnSavedMsg (void);
    void setLastCmd (int value);
    int getLastCmd (void);        
    void vuelcaPila (void);
    void setPageId (int value);
    int getPageId (void);    
    char *getLastStringCmd (int cmdactual, char *lang, char *connid, bool withhtml);    
    void addLastStringCmd (char *stcmd);
    void setNumMsgToReply (int value);
    int getNumMsgToReply(void);    
    void setSkin (char *askin);
    char *getSkin (void);
    char *getSkinAtribProp (char *propiedad);
    int getSkinAtribPropI (char *propiedad);
    bool IsWorkingWithCookies (void);
    void setWorkingWithCookies (bool b);
    bool get_use_javascript (void);
    void set_use_javascript (bool b);
    char *getSentMailName (void);
    void setSentMailName (char *smname);
    bool getConfirmPurge (void);
    void setConfirmPurge (bool b);
    bool getConfirmLogout (void);
    void setConfirmLogout (bool b);    
    void setTimeout (int value);
    int getTimeout (void);        
  };

#endif

